
#include <stdio.h>
#include <unistd.h>
#include <unistd.h>
#include <string.h>
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft2def.h"
#include "fft3def.h"
#include "screendef.h"
#include "seldef.h"
#include "sigdef.h"
#include "hwaredef.h"
#include "thrdef.h"
#include "rusage.h"
#include "options.h"



void finish_rx_read(short int *buf)
{
int i, j, k, m, ix;
if(disksave_flag == 1)
  {
  if( (ui.input_mode&DWORD_INPUT) == 0)
    {
    fwrite(buf,1,ad_read_bytes,save_file);
    }
  else
    {  
    compress_rawdat();
    fwrite(fft1_tmp,1,save_rw_bytes,save_file);
    }
  }
if(ampinfo_flag != 0)
  {
  if(rxin_local_workload_reset != workload_reset_flag)
    {
    rxin_local_workload_reset = workload_reset_flag;
    for(i=0; i<ui.ad_channels; i++)
      {
      ad_maxamp[i]=1;
      }
    }
  k=ui.ad_channels;
  m=ad_read_fragments*k;
  if( (ui.input_mode&DWORD_INPUT) == 0)
    {
    for(i=0; i<m; i+=k)
      {
//       buf[i]+=2048; // (Add a DC offset for experimentation)
      for(j=0; j<k; j++)
        {
        ix=buf[i+j];
        ix=abs(ix);        
        if(ix > ad_maxamp[j])ad_maxamp[j]=ix;
        }
      }  
    }
  else
    {
    for(i=0; i<m; i+=k)
      {
      for(j=0; j<k; j++)
        {
        ix=buf[1+((k+j)<<1)];
        ix=abs(ix);        
        if(ix > ad_maxamp[j])ad_maxamp[j]=ix;
        }
      }
    }
  }
// Increment the bufin semaphore in case there is enough
// data for fft1 to make at least one transform.
// This may be incorrect because the px pointer may have been
// updated already by the fft1 thread. This will not happen often
// and it is harmless. It will just awake the fft1 thread to
// make it find it does not have enough data. 
while( ((timf1p_pa-rxinput_local_px+timf1_bytes)&timf1_bytemask) > 
                                timf1_usebytes)
  {  
  rxinput_local_px=(rxinput_local_px+timf1_blockbytes)&timf1_bytemask;
  lir_sem_post(SEM_TIMF1);
  rxinput_posttime=0;
  }
// Make sure we do not post to SEM_TIMF1 with larger time
// intervals than TIMF1_MIN_POSTTIME seconds  
#define TIMF1_MIN_POSTTIME 0.1
rxinput_posttime+=1/TIMF1_MIN_POSTTIME;
if( rxinput_posttime > interrupt_rate)
  {
  lir_sem_post(SEM_TIMF1);
  rxinput_posttime=0;
  }
}


void rx_file_input(void)
{
fpos_t pos;
int i, j, k;
char *ch;
double dt1, read_start_time, ideal_block_count;
double total_time1, total_time2;
float t2;
#if (RUSAGE_OLD == 1)
int wlcnt,wlcnt_max;
int local_reset;
float t1,t3;
double cpu_time1;
double cpu_time2;
wlcnt_max=4*ui.input_speed/ad_read_fragments;
cpu_time1=lir_get_cpu_time();
wlcnt=wlcnt_max;
local_reset=workload_reset_flag;
#endif
i=0;
if(savefile_repeat_flag == 1)fgetpos(save_file,&pos);
total_time1=current_time();
read_start_time=total_time1;
diskread_timer=current_time();
      total_time2=current_time();
diskread_block_counter=0;
thread_status_flag[THREAD_RX_FILE_INPUT]=THRFLAG_ACTIVE;
while(thread_command_flag[THREAD_RX_FILE_INPUT] == THRFLAG_ACTIVE)
  {
#if (RUSAGE_OLD==1)
  wlcnt--;
  if(wlcnt==0)
    {
    wlcnt=wlcnt_max;
    total_time2=current_time();
    cpu_time2=lir_get_cpu_time();
    t3=100/(total_time2-total_time1);
    t1=(cpu_time2-cpu_time1)*t3;
    if(t1<0)t1=0;
    workloads[THREAD_RX_FILE_INPUT]=t1;
    if(local_reset != workload_reset_flag)
      {
      local_reset=workload_reset_flag;
      total_time1=total_time2;
      cpu_time1=cpu_time2;
      }
    }
#endif
  if(audio_dump_flag != 0)
    {
    lir_sched_yield();
    while( ((timf1p_pa+(ad_read_bytes<<1)-timf1p_px+timf1_bytes)&
                        timf1_bytemask) > timf1_bytes-(ad_read_bytes<<1) )
      {
      lir_sleep(5000);
      }
    lir_sem_post(SEM_SCREEN);
    ideal_block_count=diskread_block_counter-0.4;
    dt1=ideal_block_count/interrupt_rate;
    read_start_time=current_time()-dt1;
    }
  else
    {  
    if(diskread_block_counter > interrupt_rate)
      {
      lir_sem_post(SEM_SCREEN);
      total_time2=current_time();
      dt1=total_time2-read_start_time;
      ideal_block_count=dt1*interrupt_rate;
      t2=diskread_block_counter-ideal_block_count-0.6;
      if(t2 >0)
        {
        t2/=interrupt_rate;
        lir_sleep(1000000*t2);
        }
      total_time2=current_time();
      dt1=total_time2-read_start_time;
      measured_ad_speed=diskread_block_counter*(ad_read_fragments/dt1);
      }
    }
  diskread_block_counter++;
  if(diskread_pause_flag !=0 )goto skip_read;
  if( disksave_flag == 4)goto end_savfile;
  if( (ui.input_mode&DWORD_INPUT) == 0)
    {
    rxin_isho=(void*)(&timf1_char[timf1p_pa]);
    timf1p_pa=(timf1p_pa+ad_read_bytes)&timf1_bytemask;
    if( (ui.input_mode&BYTE_INPUT) != 0)
      {
      ch=(void*)rxin_isho;
      j=ad_read_bytes>>1;
      k=j;
      i=fread(rxin_isho,1,j,save_file);
      while(j > 0)
        {
        j--;
        rxin_isho[j]=(ch[j]+128)<<8;
        } 
      if(i != k)
        {
        i*=2;
        goto end_savfile;
        }
      }
    else
      {  
      i=fread(rxin_isho,1,ad_read_bytes,save_file);
      if(i != ad_read_bytes)goto end_savfile;
      }
    }
  else
    {  
    i=fread(fft1_tmp,1,save_rw_bytes,save_file);
    expand_rawdat();
    rxin_isho=(void*)(&timf1_char[timf1p_pa]);
    timf1p_pa=(timf1p_pa+ad_read_bytes)&timf1_bytemask;
    if(i != save_rw_bytes)
      {
end_savfile:;        
      if(savefile_repeat_flag == 1)
        {
        fsetpos(save_file,&pos);
total_time1=current_time();
read_start_time=total_time1;
diskread_timer=current_time();
diskread_block_counter=0;
        }
      else
        {
        if(disksave_flag == 2)
          {
          diskread_block_counter=2;
          disksave_flag=4;
          }
        if( (disksave_flag & 4) != 0)
          {
          if(diskread_block_counter/interrupt_rate >= total_wttim)
            {
            disksave_flag=8;
            goto end_file_rxin;
            }
          }                                                                
        }
      k=(timf1p_pa-ad_read_bytes+i+timf1_bytes)&timf1_bytemask;
      while(k != timf1p_pa)
        {
        timf1_char[k]=0;
        k=(k+1)&timf1_bytemask;
        }
      }
    }
  finish_rx_read(rxin_isho);
  if(kill_all_flag) goto file_rxin_error_exit;
skip_read:;
  }
end_file_rxin:;
file_rxin_error_exit:;
thread_status_flag[THREAD_RX_FILE_INPUT]=THRFLAG_RETURNED;
while(thread_command_flag[THREAD_RX_FILE_INPUT] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }

}


void rx_raw_netinput(void)
{
double dt1, read_start_time,total_reads;
double total_time1,total_time2;
int i;
int timing_loop_counter,timing_loop_counter_max,initial_skip_flag;
int screen_loop_counter,screen_loop_counter_max;
#if (RUSAGE_OLD == 1)
int wlcnt,wlcnt_max;
int local_reset;
float t1,t3;
double cpu_time1;
double cpu_time2;
cpu_time1=lir_get_cpu_time();
wlcnt_max=2*interrupt_rate;
wlcnt=wlcnt_max;
local_reset=workload_reset_flag;
#endif
total_time1=current_time();
read_start_time=total_time1;
rxinput_local_px=timf1p_pa;
rxin_local_workload_reset=workload_reset_flag;
timing_loop_counter_max=interrupt_rate;
timing_loop_counter=2.5*timing_loop_counter_max;
screen_loop_counter_max=0.1*interrupt_rate;
if(screen_loop_counter_max==0)screen_loop_counter_max=1;
screen_loop_counter=interrupt_rate;
total_reads=0;
initial_skip_flag=1;
thread_status_flag[THREAD_RX_RAW_NETINPUT]=THRFLAG_ACTIVE;
while(thread_command_flag[THREAD_RX_RAW_NETINPUT] == THRFLAG_ACTIVE)
  {
#if (RUSAGE_OLD==1)
  wlcnt--;
  if(wlcnt==0)
    {
    wlcnt=wlcnt_max;
    total_time2=current_time();
    cpu_time2=lir_get_cpu_time();
    t3=100/(total_time2-total_time1);
    t1=(cpu_time2-cpu_time1)*t3;
    if(t1<0)t1=0;
    workloads[THREAD_RX_RAW_NETINPUT]=t1;
    if(local_reset != workload_reset_flag)
      {
      local_reset=workload_reset_flag;
      total_time1=total_time2;
      cpu_time1=cpu_time2;
      }
    }
#endif
  timing_loop_counter--;
  if(timing_loop_counter == 0)
    {
    timing_loop_counter=timing_loop_counter_max;
    total_time2=current_time();
    if(initial_skip_flag != 0)
      {
      read_start_time=total_time2;
      total_reads=0;
      initial_skip_flag=0;
      }
    else
      {
      total_reads+=timing_loop_counter_max;
      dt1=total_time2-read_start_time;
      measured_ad_speed=total_reads*ad_read_fragments/dt1;
      }
    }
// Here we post to the screen routine every 0.1 second.      
  screen_loop_counter--;
  if(screen_loop_counter == 0)
    {
    screen_loop_counter=screen_loop_counter_max;
    lir_sem_post(SEM_SCREEN);
    }
  rxin_isho=(void*)(&timf1_char[timf1p_pa]);
  timf1p_pa=(timf1p_pa+ad_read_bytes)&timf1_bytemask;
/*
wtn:;        
  if(ioctl(network_fd, FIONREAD, &i)==-1)lirerr(9999);
  if(i<ad_read_bytes+16)
    {
    usleep(1000);
    goto wtn;
    }
*/        
  read(network_fd, &i, sizeof(int));
  if(i != 0)
    {
    read(network_fd,&fg.passband_center,sizeof(double));
    read(network_fd,&fg.passband_direction,sizeof(int));
    fft1_direction=fg.passband_direction;
    }
  read(network_fd, rxin_isho, ad_read_bytes);
  finish_rx_read(rxin_isho);
  if(kill_all_flag) goto rawnet_rxin_error_exit;
  }
rawnet_rxin_error_exit:;
thread_status_flag[THREAD_RX_RAW_NETINPUT]=THRFLAG_RETURNED;
while(thread_command_flag[THREAD_RX_RAW_NETINPUT] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }
}

void rx_fft1_netinput(void)
{
double dt1, read_start_time,total_reads;
double total_time1,total_time2;
int i;
int timing_loop_counter,timing_loop_counter_max,initial_skip_flag;
int screen_loop_counter,screen_loop_counter_max;
#if (RUSAGE_OLD == 1)
int wlcnt,wlcnt_max;
int local_reset;
float t1,t3;
double cpu_time1;
double cpu_time2;
cpu_time1=lir_get_cpu_time();
wlcnt_max=2*interrupt_rate;
wlcnt=wlcnt_max;
local_reset=workload_reset_flag;
#endif
total_time1=current_time();
read_start_time=total_time1;
rxinput_local_px=timf1p_pa;
rxin_local_workload_reset=workload_reset_flag;
timing_loop_counter_max=interrupt_rate;
timing_loop_counter=2.5*timing_loop_counter_max;
screen_loop_counter_max=0.1*interrupt_rate;
if(screen_loop_counter_max==0)screen_loop_counter_max=1;
screen_loop_counter=interrupt_rate;
total_reads=0;
initial_skip_flag=1;
thread_status_flag[THREAD_RX_FFT1_NETINPUT]=THRFLAG_ACTIVE;
while(thread_command_flag[THREAD_RX_FFT1_NETINPUT] == THRFLAG_ACTIVE)
  {
#if (RUSAGE_OLD==1)
  wlcnt--;
  if(wlcnt==0)
    {
    wlcnt=wlcnt_max;
    total_time2=current_time();
    cpu_time2=lir_get_cpu_time();
    t3=100/(total_time2-total_time1);
    t1=(cpu_time2-cpu_time1)*t3;
    if(t1<0)t1=0;
    workloads[THREAD_RX_FFT1_NETINPUT]=t1;
    if(local_reset != workload_reset_flag)
      {
      local_reset=workload_reset_flag;
      total_time1=total_time2;
      cpu_time1=cpu_time2;
      }
    }
#endif
  timing_loop_counter--;
  if(timing_loop_counter == 0)
    {
    timing_loop_counter=timing_loop_counter_max;
    total_time2=current_time();
    if(initial_skip_flag != 0)
      {
      read_start_time=total_time2;
      total_reads=0;
      initial_skip_flag=0;
      }
    else
      {
      total_reads+=timing_loop_counter_max;
      dt1=total_time2-read_start_time;
      measured_ad_speed=total_reads*ad_read_fragments/dt1;
      }
    }
// Here we post to the screen routine every 0.1 second.      
  screen_loop_counter--;
  if(screen_loop_counter == 0)
    {
    screen_loop_counter=screen_loop_counter_max;
    lir_sem_post(SEM_SCREEN);
    }
  rxin_isho=(void*)(&timf1_char[timf1p_pa]);
  timf1p_pa=(timf1p_pa+ad_read_bytes)&timf1_bytemask;
  if(network_flag == 2)
/*
  if(ioctl(network_fd, FIONREAD, &i)==-1)
    {
    lirerr(9999);
    return;
    }
  if(i < fft1_blockbytes+16)
    {
    lirerr(2363);
    return;
    }
*/
  read(network_fd, &i, sizeof(int));
  if(i != 0)
    {
    read(network_fd,&fg.passband_center,sizeof(double));
    read(network_fd,&fg.passband_direction,sizeof(int));
    fft1_direction=fg.passband_direction;
    }
  if(fft1_pa == fft1_px)timerr(0," network read fft1");
  read(network_fd, &fft1_float[fft1_pa], fft1_blockbytes);
  fft1_pa=(fft1_pa+fft1_block)&fft1_mask;  
  fft1_na=fft1_pa/fft1_block;
  if(fft1_nm != fft1n_mask)fft1_nm++;
  if(fft1_sumsq_pws != fft1_sumsq_pa ) update_fft1_slowsum();
  if( genparm[SECOND_FFT_ENABLE] == 0 ) 
    {
    fft1_waterfall();
    lir_sem_post(SEM_FFT1);
    }
  else
    {  
    make_timf2();
    first_noise_blanker();
// Add the two parts of timf2 so we get a single time function
// and produce the second fft.
// Note that the fft2 routine still is split into a number of small
// chunks so we have to call until the flag is set.
    while( ((timf2_pn2-timf2_px+timf2_totbytes)&timf2_mask) >=
                                               4*ui.rx_channels*fft2_size )
      {
      make_fft2_status=FFT2_NOT_ACTIVE;
      while(make_fft2_status != FFT2_COMPLETE)
        {
        make_fft2();
        }
      lir_sem_post(SEM_FFT1);
      }
    }
  }
thread_status_flag[THREAD_RX_FFT1_NETINPUT]=THRFLAG_RETURNED;
while(thread_command_flag[THREAD_RX_FFT1_NETINPUT] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }
}

